UIPackage
Menu

Framework

Change language

Boilerplate repo

Pictorial Bar Chart

pictorial-bar-chartui

Pictorial bar chart around Apache ECharts. Repeated symbols fill to the value with a configurable symbol shape. Theme-aware via registry tokens.

Also available for React ->

Installation

$npx shadcn-vue@latest add https://uipkge.dev/r/vue/pictorial-bar-chart.json
Named registry:npx shadcn-vue@latest add @uipkge/pictorial-bar-chartInstalls to:app/components/ui/charts/pictorial-bar-chart/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
data{ category: string; value: number }[]required
symbol

ECharts symbol for the repeated pictogram. Default 'rect'.

string'rect'optional
heightnumber | string300optional
optionanyoptional
classstringoptional
ariaLabel

Accessible name announced for the chart image. Defaults to "Chart".

stringoptional

npm dependencies

Used by

Files installed (3)

  • app/components/ui/charts/pictorial-bar-chart/PictorialBarChart.vue3.1 kB
    <script setup lang="ts">
    import { computed } from 'vue'
    import { use } from 'echarts/core'
    import { CanvasRenderer } from 'echarts/renderers'
    import { PictorialBarChart as EChartsPictorialBar } from 'echarts/charts'
    import { GridComponent, TooltipComponent } from 'echarts/components'
    import VChart from 'vue-echarts'
    import { cn } from '@/lib/utils'
    import {
      chartColors,
      chartTextColor,
      chartAxisColor,
      chartSplitLineColor,
      chartTooltipBg,
      chartTooltipBorder,
      chartTooltipText,
      mergeOptionBlock,
    } from '../useChartTheme'
    
    use([CanvasRenderer, EChartsPictorialBar, GridComponent, TooltipComponent])
    
    interface Props {
      data: { category: string; value: number }[]
      /** ECharts symbol for the repeated pictogram. Default 'rect'. */
      symbol?: string
      height?: number | string
      option?: any
      class?: string
      /** Accessible name announced for the chart image. Defaults to "Chart". */
      ariaLabel?: string
    }
    
    const props = withDefaults(defineProps<Props>(), {
      symbol: 'rect',
      height: 300,
    })
    
    const mergedOption = computed(() => {
      const max = Math.max(...props.data.map((d) => d.value), 1)
      const series = [
        {
          type: 'pictorialBar',
          symbol: props.symbol,
          symbolRepeat: true,
          symbolSize: [12, 8],
          symbolMargin: 2,
          symbolClip: true,
          itemStyle: { color: chartColors.value[0] },
          data: props.data.map((d) => ({ value: d.value, symbolBoundingData: max })),
        },
      ]
    
      const userOption: any = props.option ?? {}
      const {
        series: userSeries,
        xAxis: userXAxis,
        yAxis: userYAxis,
        grid: userGrid,
        tooltip: userTooltip,
        ...userRest
      } = userOption
      const mergedSeries = Array.isArray(userSeries) ? series.map((s, i) => ({ ...s, ...(userSeries[i] ?? {}) })) : series
    
      return {
        color: chartColors.value,
        grid: mergeOptionBlock({ left: 16, right: 16, top: 24, bottom: 24, containLabel: true }, userGrid),
        tooltip: mergeOptionBlock(
          {
            trigger: 'item',
            backgroundColor: chartTooltipBg.value,
            borderColor: chartTooltipBorder.value,
            textStyle: { color: chartTooltipText.value, fontSize: 12 },
          },
          userTooltip,
        ),
        xAxis: mergeOptionBlock(
          {
            type: 'category',
            data: props.data.map((d) => d.category),
            axisLine: { lineStyle: { color: chartAxisColor.value } },
            axisLabel: { color: chartTextColor.value, fontSize: 11 },
            axisTick: { show: false },
          },
          userXAxis,
        ),
        yAxis: mergeOptionBlock(
          {
            type: 'value',
            max,
            splitLine: { lineStyle: { color: chartSplitLineColor.value } },
            axisLabel: { color: chartTextColor.value, fontSize: 11 },
          },
          userYAxis,
        ),
        series: mergedSeries,
        ...userRest,
      }
    })
    </script>
    
    <template>
      <div
        role="img"
        tabindex="0"
        :aria-label="ariaLabel || 'Chart'"
        :style="{ height: /^\d+$/.test(String(height)) ? `${height}px` : String(height) }"
        :class="cn('focus-visible:ring-ring w-full focus-visible:ring-2 focus-visible:outline-none', props.class)"
      >
        <VChart :option="mergedOption" :autoresize="true" class="size-full" />
      </div>
    </template>
    
  • app/components/ui/charts/pictorial-bar-chart/index.ts0.1 kB
  • app/components/ui/charts/useChartTheme.ts8.2 kB

Raw manifest:https://uipkge.dev/r/vue/pictorial-bar-chart.json

UIPackage
Menu

Framework

Change language

Boilerplate repo

Pictorial Bar Chart

pictorial-bar-chartui

React mirror of @uipkge/pictorial-bar-chart — see the Vue registry item for the canonical description.

Also available for Vue ->

Installation

$npx shadcn@latest add https://uipkge.dev/r/react/pictorial-bar-chart.json
Named registry:npx shadcn@latest add @uipkge-react/pictorial-bar-chartInstalls to:components/ui/charts/pictorial-bar-chart/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
data{ category: string; value: number }[]required
symbol

ECharts symbol for the repeated pictogram. Default 'rect'.

stringrectoptional
heightnumber | string300optional
optionanyoptional
classNamestringoptional
ariaLabel

Accessible name announced for the chart image. Defaults to "Chart".

stringoptional

Schema

Type aliases from this item's source — use them to shape the data you pass in.

ChartTheme
interface ChartTheme {
  colors: string[]
  textColor: string
  axisColor: string
  splitLineColor: string
  tooltipBg: string
  tooltipBorder: string
  tooltipText: string
  bgColor: string
  /** The app's accent, for the one highlighted element on a chart or map —
   *  a selected route, a focused bar. Category series keep using `colors`. */
  accentColor: string
  /** Out-of-bounds / failure colour for charts that encode good vs bad
   *  rather than a category — control limits, error series. CSS-level marks
   *  can use `var(--destructive)` directly; this exists because ECharts needs
   *  a resolved colour string on the canvas. */
  dangerColor: string
}

npm dependencies

Used by

Files installed (4)

  • components/ui/charts/pictorial-bar-chart/PictorialBarChart.tsx2.9 kB
    'use client'
    
    import * as React from 'react'
    import { ChartFrame, EChart } from '../shared'
    import { useChartTheme, mergeOptionBlock } from '../useChartTheme'
    
    // PictorialBarChart
    // ─────────────────────────────────────────────────────────────────────────
    
    export interface PictorialBarChartProps {
      data: { category: string; value: number }[]
      /** ECharts symbol for the repeated pictogram. Default 'rect'. */
      symbol?: string
      height?: number | string
      option?: any
      className?: string
      /** Accessible name announced for the chart image. Defaults to "Chart". */
      ariaLabel?: string
    }
    
    export const PictorialBarChart = React.forwardRef<HTMLDivElement, PictorialBarChartProps>(
      ({ data, symbol = 'rect', height = 300, option, className, ariaLabel }, ref) => {
        const theme = useChartTheme()
    
        const mergedOption = React.useMemo(() => {
          const max = Math.max(...data.map((d) => d.value), 1)
          const series = [
            {
              type: 'pictorialBar',
              symbol,
              symbolRepeat: true,
              symbolSize: [12, 8],
              symbolMargin: 2,
              symbolClip: true,
              itemStyle: { color: theme.colors[0] },
              data: data.map((d) => ({ value: d.value, symbolBoundingData: max })),
            },
          ]
          const userOption: any = option ?? {}
          const {
            series: userSeries,
            xAxis: userXAxis,
            yAxis: userYAxis,
            grid: userGrid,
            tooltip: userTooltip,
            ...userRest
          } = userOption
          const mergedSeries = Array.isArray(userSeries)
            ? series.map((s, i) => ({ ...s, ...(userSeries[i] ?? {}) }))
            : series
    
          return {
            color: theme.colors,
            grid: mergeOptionBlock({ left: 16, right: 16, top: 24, bottom: 24, containLabel: true }, userGrid),
            tooltip: mergeOptionBlock(
              {
                trigger: 'item',
                backgroundColor: theme.tooltipBg,
                borderColor: theme.tooltipBorder,
                textStyle: { color: theme.tooltipText, fontSize: 12 },
              },
              userTooltip,
            ),
            xAxis: mergeOptionBlock(
              {
                type: 'category',
                data: data.map((d) => d.category),
                axisLine: { lineStyle: { color: theme.axisColor } },
                axisLabel: { color: theme.textColor, fontSize: 11 },
                axisTick: { show: false },
              },
              userXAxis,
            ),
            yAxis: mergeOptionBlock(
              {
                type: 'value',
                max,
                splitLine: { lineStyle: { color: theme.splitLineColor } },
                axisLabel: { color: theme.textColor, fontSize: 11 },
              },
              userYAxis,
            ),
            series: mergedSeries,
            ...userRest,
          }
        }, [data, symbol, option, theme])
    
        return (
          <ChartFrame ref={ref} height={height} className={className} ariaLabel={ariaLabel}>
            <EChart option={mergedOption} />
          </ChartFrame>
        )
      },
    )
    PictorialBarChart.displayName = 'PictorialBarChart'
    
  • components/ui/charts/pictorial-bar-chart/index.ts0.1 kB
  • components/ui/charts/useChartTheme.ts8.7 kB
  • components/ui/charts/shared.tsx3.7 kB

Raw manifest:https://uipkge.dev/r/react/pictorial-bar-chart.json